% Solution for Exercise 10.1: Preconditioning
%

function pre_gmres(A,b)

exact_sol = A\b;

%setup.type = 'nofill';
setup.type = 'crout'; setup.droptol = 0.1;
[L,U]=ilu(A,setup);  % ILU
whos A L U

% Now let's solve Ax=b in three ways.

% 1, split preconditioning
fprintf('split preconditioning:\n');
z=gmres(@afun1, b, 10, 1e-8,100, L);
x1=U\z;
err = norm(x1-exact_sol)

fprintf('\n');

% 2, left preconditioning.
fprintf('left preconditioning:\n');
x2=gmres(A,b,10, 1e-8,100,L,U);

err = norm(x2-exact_sol)

fprintf('\n');

% 2, right preconditioning.
fprintf('right preconditioning:\n');
x3=gmres(@afun3,b,10,1e-8,100);
x3=U\(L\x3);

err = norm(x3-exact_sol)
fprintf('\n');
    
function y = afun1(x)
   y1 = U\x;
   y = A*y1;
end

function y = afun3(x)
   y1 = U\(L\x);
   y = A*y1;
end
end
