%% Solution for Exercise 10.3

g = 'squareg';
bcond = 'squareb1';
c = 1; a = 0; f = 1;

% Here, if you do 4 refinement, then 
[p,e,t] = initmesh(g,'hmax',1.3);          % generate a coarse mesh
[p,e,t] = refinemesh(g,p,e,t);  % refine the mesh
[p,e,t] = refinemesh(g,p,e,t);  % refine the mesh
[p,e,t] = refinemesh(g,p,e,t);  % refine the mesh
[p,e,t] = refinemesh(g,p,e,t);  % refine the mesh

[A,b]=assempde(bcond,p,e,t,c,a,f);
N=size(A,1)
M=100;

% here we generates the random matrix here just to test if the
% preconditioner work.  Of course in the real Stokes matrix, you need to
% generate B matrix from the weak form.  That is out of the range of this
% lecture.
B=sprand(M,N,0.01); 

zero1=zeros(M,M);
zero2=zeros(M,N);

AA=[A,B';B,zero1];
%spy(AA);
%pause;

% (1) only for small-size problem, e.g., if only 5 refinemesh steps are
% executed.

sprintf(['(1) if we use the preconditioner with the Shur complement for ' ...
         'the (2,2) block, it only works for small-size problem.\n']);
S=B*(A\B');  % if size of A is large, then this is very expensive.
MM=[A,zero2';zero2,S];
%spy(MM);
[x,flag,relres,iter1] = minres(AA,rand(M+N,1),1e-6,5,MM);
iter1

% (2) also for large-size problem, e.g. 7 refinement steps are executed.
% This is the simplest preconditioner for this kind of problems.

sprintf(['(2) we approximate A and S to construct a new preconditioner ' ...
         'which can also work for large-size system\n']);
D=diag(diag(A));
MM=[D,zero2';zero2,B*(D\B')]; % computing inv(D) is not expensive.
MM = chol(MM,'lower');
[x,flag,relres,iter2] = minres(AA,rand(M+N,1),1e-6,300,MM,MM');
iter2
